//----------------------------------------------------------------
//
// Copyright 1998-2010 (c) RC Module.
// NeuroChip NM6405.
//
// nc_int05.h
// Header file for low level library.
// Contain declaration of timer, comm. port and interrupt managing function
//
//----------------------------------------------------------------

#ifndef _NC_INT_H
#define _NC_INT_H

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

///////////////////////////////////
//  
///////////////////////////////////

//      :  
//       
//     

//       
void StartTimerRepeat_T0();
void StartTimerRepeat_T1();
//      
void StartTimerOnce_T0();
void StartTimerOnce_T1();
//   
void StopTimer_T0();
void StopTimer_T1();
//    
unsigned int SetTimerCounter_T0( unsigned int );
unsigned int SetTimerCounter_T1( unsigned int );
//    
unsigned int GetTimerCounter_T0();
unsigned int GetTimerCounter_T1();

///////////////////////////////////
//  
///////////////////////////////////


typedef void (HandlerType)(void);

enum InterKind
{
    I_KIND_NMI =0,  //   
    I_KIND_OF,      //  
    I_KIND_EI,      //   
    I_KIND_ST,      //   
    I_KIND_PE,      //       
                    //        ,    
                    //            
    I_KIND_T0,      //     0
    I_KIND_INT3,    //    0
    I_KIND_INT2,    //    1
    I_KIND_INT1,    //    2
    I_KIND_INT0,    //    3
    I_KIND_T1,      //     1
    I_KIND_DMA0,    //       0
    I_KIND_DMA1,    //       1
    I_KIND_CPI1,    //       1
    I_KIND_CPI0,    //       0
    I_KIND_CPO1,    //       1
    I_KIND_CPO0,    //       0
    I_KIND_MAX = I_KIND_CPO0
};

//   -
extern HandlerType DefaultIntHandler;

//    
HandlerType*       //   
SetInterrupt05( InterKind k, HandlerType f );

//     
HandlerType* GetInterrupt05( InterKind k );

//      
HandlerType* ClearInterrupt05( InterKind k );

//      
HandlerType* FlushInterrupts05( );

enum InterMaskPSWR
{
    I_MASK_OF = 0x00000100,      //  
    I_MASK_EI = 0x00000080,      //   
    I_MASK_INM =0x00000040,      //   
    I_MASK_ST = 0x00000020       //   
};

enum InterMaskPeriphery
{
    I_IMR_NONE = 0    ,    //     
    I_IMR_CPO0 = 0x001,    //       0
    I_IMR_CPO1 = 0x002,    //       1
    I_IMR_CPI0 = 0x004,    //       0
    I_IMR_CPI1 = 0x008,    //       1
    I_IMR_DMA1 = 0x010,    //       1
    I_IMR_DMA0 = 0x020,    //       0
    I_IMR_T1 =   0x040,    //     1
    I_IMR_INT0 = 0x080,    //    3
    I_IMR_INT1 = 0x100,    //    2
    I_IMR_INT2 = 0x200,    //    1
    I_IMR_INT3 = 0x400,    //    0
    I_IMR_T0 =   0x800,    //     0
    I_IMR_PE =  0x1000     //        
};


//    .
void EnableInterrupts ( InterMaskPSWR, InterMaskPeriphery imp=I_IMR_NONE );

//    .
void DisableInterrupts ( InterMaskPSWR, InterMaskPeriphery imp=I_IMR_NONE );

//     
int GetInterruptMaskIMR ( void );


///////////////////////////////////
//  . 
///////////////////////////////////

//  \  64-. 
//    -  \ 
//    -  64-,   !
//   1  , 0,    . 
//     
int SendArrayCom0( long long* start, int sz );
int SendArrayCom1( long long* start, int sz );
int ReceiveArrayCom0( long long* start, int sz );
int ReceiveArrayCom1( long long* start, int sz );
//   
int GetInCounterCom0();
int GetInCounterCom1();
int GetOutCounterCom0();
int GetOutCounterCom1();
//  ,  ,  .
void ResetComs();

///////////////////////////////////
//  
///////////////////////////////////


//     
unsigned int LibintGetPCR();
unsigned int LibintGetPSWR();
//     
unsigned int EnableHWStackTop();
unsigned int DisableHWStackTop();
//    
unsigned int EnableInstrCache();
unsigned int DisableInstrCache();


#ifdef __cplusplus
}
#endif // __cplusplus

#endif // _NC_INT_H
